diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/ChangeLog gcc-4.1.1/gcc/ChangeLog
--- gcc-4.1.1.orig/gcc/ChangeLog	2006-05-25 00:42:18.000000000 +0100
+++ gcc-4.1.1/gcc/ChangeLog	2006-08-10 09:56:05.000000000 +0100
@@ -1,4 +1,3 @@
-2006-05-24  Release Manager
 
 	* GCC 4.1.1 released.
 
@@ -8,6 +7,58 @@ 	* doc/install.texi (Configuration): Rem
 	FAQ which was hijacked.
 	(Building): Ditto.
 
+ *** patches from gcc-patches *** :
+
+http://gcc.gnu.org/ml/gcc-patches/2006-04/msg00194.html
+2006-04-05  Rask Ingemann Lambertsen <rask@sygehus.dk>
+            J"orn Rennecke <joern.rennecke@st.com>
+
+	* combine.c (likely_spilled_retval_1): Fix masking operation.
+	(likely_spilled_retval_p): Use proper pattern for call to
+	likely_spilled_retval_1.
+
+ *** Patches from mainline *** :
+
+2006-03-28  Kaz Kojima  <kkojima@gcc.gnu.org>
+
+	* config/sh/sh.md (udivsi3_i4_int): Clobber MACH_REG and MACL_REG.
+	(divsi3_i4_int): Likewise.
+
+2006-03-23  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/divtab-sh4.c, config/sh/divcost-analysis: New files.
+	* config/sh/lib1funcs.asm (div_table): Add !__SH5__ variant.
+	* config/sh/t-sh (LIB1ASMFUNCS): Add _div_table.
+	* config/sh/sh.opt (mdiv=): Amend description.
+	* config/sh/sh.h (TARGET_DIVIDE_CALL_DIV1): New macro.
+	(TARGET_DIVIDE_CALL_FP, TARGET_DIVIDE_CALL_TABLE): Likewise.
+	(sh_divide_strategy_e): Add new members SH_DIV_CALL_DIV1,
+	SH_DIV_CALL_FP, SH_DIV_CALL_TABLE and SH_DIV_INTRINSIC.
+	(OVERRIDE_OPTIONS): Also process sh_div_str for TARGET_SH1.
+	Calculate sh_divsi3_libfunc using TARGET_DIVIDE_* macros.
+	* config/sh/sh.md (udivsi3_i4_int, divsi3_i4_int): New patterns.
+	(udivsi3, divsi3): Use them.  Check TARGET_DIVIDE_CALL_TABLE /
+	TARGET_DIVIDE_CALL_FP.
+
+2006-03-15  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/predicates.md (cache_address_operand): Special.
+	(ua_address_operand): Likewise.
+
+2006-03-10  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config.gcc (sh*-superh-elf, sh*elf (newlib)): Use newlib.h
+	when building with libgloss.
+	(sh*elf): Implement --without-fp option.
+	(sh64-superh-linux*): Don't multilib. 
+
+2005-12-13  J"orn Rennecke <joern.rennecke@st.com>
+
+	* rtlhooks.c (gen_lowpart_general): Handle SUBREGs of floating point
+	values.
+
+ *** Patches from gcc 4.1 branch *** :
+
 2006-05-17  H.J. Lu  <hongjiu.lu@intel.com>
 
 	* Makefile.in: Undo the last 2 changes.
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/ChangeLog.STM gcc-4.1.1/gcc/ChangeLog.STM
--- gcc-4.1.1.orig/gcc/ChangeLog.STM	1970-01-01 01:00:00.000000000 +0100
+++ gcc-4.1.1/gcc/ChangeLog.STM	2006-08-10 09:56:05.000000000 +0100
@@ -0,0 +1,524 @@
+2006-07-04  J"orn Rennecke  <joern.rennecke@st.com>
+
+	PR tree-optimization/28144
+	* fold-const.c (fold_convert_const_int_from_real): Fix endianness in
+	real_from_integer calls; adjust high word for lower bound.
+
+2006-07-04  Andrew Stubbs  <andrew.stubbs@st.com>
+
+	Fix INSbl24460:
+	* config/sh/crt1.asm (vbr_start): Move to new section .test.vbr.
+	Remove pointless handler at VBR+0.
+	(vbr_200, vbr_300, vbr_500): Remove pointless handler.
+	(vbr_600): Save and restore mach and macl, fpul and fpscr and fr0 to
+	fr7. Make sure the timer handler is called with the correct FPU
+	precision setting, according to the ABI.
+
+2006-06-23  J"orn Rennecke <joern.rennecke@st.com>
+
+	PR tree-optimization/28144
+	* fold-const.c (fold_convert_const_int_from_real): When converting
+	to a type with a precision less than 32, use INT_MIN / INT_MAX
+	for saturation bounds.
+
+2006-06-23  J"orn Rennecke <joern.rennecke@st.com>
+
+	* testsuite/g++.dg/eh/alias.C: New test.
+
+2006-06-14  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/sh.opt (m2a-single, m2a-single-only): Fix Condition.
+	* config/sh/sh.h (SUPPORT_SH2A_NOFPU): Fix condition.
+	(SUPPORT_SH2A_SINGLE_ONLY, SUPPORT_SH2A_SINGLE_ONLY): Likewise.
+
+2006-06-14  J"orn Rennecke <joern.rennecke@st.com>
+
+	* Makefile.in (version.o): Depend on $(OBJS) except for version.o .
+
+2006-06-13  J"orn Rennecke <joern.rennecke@st.com>
+
+	* t-sh (MULTILIB_MATCHES): Add and m4-100-nofpu,m4-200-nofpu.
+
+2006-06-09  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.md (cmpgeusi_t): Change into define_insn_and_split.  Accept
+	zero as second operand.
+
+2006-06-08  J"orn Rennecke <joern.rennecke@st.com>
+
+	* longlong.h (__sh__ udiv_qrnnd): Add "pr" clobber.
+
+2006-06-07  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/lib1funcs.h (SL, SL1): Define.
+	* config/sh/lib1funcs.asm (__udiv_qrnnd16): Detect truncation-causes
+	overflow.
+
+2006-06-06  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/t-sh (LIB1ASMFUNCS): Add _udiv_qrnnd16
+	* config/sh/sh.c (print_operand): Add !SHMEDIA functionality to 'M'.
+	* config/sh/lib1funcs.asm (__udiv_qrnnd16): New hidden function.
+	* longlong.h (__sh__): Define umul_ppmm, udiv_qrnnd and sub_ddmmss.
+	* config/sh/t-sh ($(T)unwind-dw2-Os-4-200.o): New rule.
+	(OBJS_Os_4_200): New variable.
+	($(T)libgcc-Os-4-200.a): Use it.
+	* sh.md (udivsi3): For TARGET_DIVIDE_CALL_TABLE, avoid function call
+	when dividing 1.
+
+2006-05-09  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/sh.c (expand_cbranchdi4): Avoid calling
+	swap_condition (CODE_FOR_nothing).
+
+2006-05-03  Andrew Stubbs  <andrew.stubbs@st.com>
+            J"orn Rennecke <joern.rennecke@st.com>
+
+	* gcc.c (process_command): Try to set gcc_exec_prefix with
+	make_relative_prefix_ignore_links before resolving to
+	make_relative_prefix.
+	If gcc_exec_prefix has been pre-set, use
+	make_relative_prefix_ignore_links to calculate gcc_libexec_prefix.
+
+2006-04-28  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/divtab-sh4-300.c, config/sh/lib1funcs-4-300.asm:
+	Fixed some bugs related to nagative values, in particular -0
+	and overflow at -0x80000000.
+	* config/sh/divcost-analysis: added sh4-300 figures.
+	* testsuite/gcc.c-torture/execute/arith-rand-ll.c:
+	Also test for bogus rest sign.
+
+2006-04-27  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/t-sh (MULTILIB_MATCHES): Add -m4-300* / -m4-340 options.
+
+2006-04-27  J"orn Rennecke <joern.rennecke@st.com>
+
+	* builtins.c (get_pointer_alignment): Fix bug in last change.
+
+2006-04-26  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.c (expand_cbranchdi4): Avoid generating >= 0U tests.
+
+2006-04-26  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/t-sh (OPT_EXTRA_PARTS): Add libgcc-4-300.a.
+	($(T)div_table-4-300.o, $(T)libgcc-4-300.a): New rules.
+	* config/sh/divtab-sh4-300.c, config/sh/lib1funcs-4-300.asm: New files.
+	* config/sh/embed-elf.h (LIBGCC_SPEC): Use -lgcc-4-300 for -m4-300* /
+	-m4-340.
+
+	* config/sh/sh.opt: Amend -mdiv= option description.
+
+2006-04-24  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.md (mulr03, mulr03+1, mulr03+2): New patterns.
+	(mulsi3) Use mulr03 for TARGET_R0R3_TO_REG_MUL.
+	* sh.h (CONDITIONAL_REGISTER_USAGE): If -mr0r3-to-reg-mul is not in
+	effect, set regno_reg_class for R1_REG .. R3_REG to GENERAL_REGS.
+	(OVERRIDE_OPTIONS): Initilize TARGET_R0R3_TO_REG_MUL if it has
+	not been set by an option.
+	(enum reg_class, REG_CLASS_NAMES, REG_CLASS_CONTENTS): Add R0R3_REGS.
+	(REG_CLASS_FROM_CONSTRAINT): Decode R03.
+	* sh.opt (mlate-r0r3-to-reg-mul, mr0r3-to-reg-mul): New options.
+
+	SH4-300 scheduling description & fixes to SH4-[12]00 description:
+	* sh.md: New instruction types: fstore, movi8, fpscr_toggle, gp_mac,
+	mac_mem, mem_mac, dfp_mul, fp_cmp.
+	(insn_class, dfp_comp, any_fp_comp): Update.
+	(push_fpul, movsf_ie, fpu_switch, toggle_sz, toggle_pr): Update type.
+	(cmpgtsf_t, "cmpeqsf_t, cmpgtsf_t_i4, cmpeqsf_t_i4): Likewise.
+	(muldf3_i): Likewise.
+	(movsi_i): Split rI08 alternative into two separate alternatives.
+	Update type.
+	(movsi_ie, movsi_i_lowpart): Likewise.
+	(movqi_i): Split ri alternative into two separate alternatives.
+	Update type.
+	* sh1.md (sh1_load_store, sh1_fp): Update.
+	* sh4.md (sh4_store, sh4_mac_gp, fp_arith, fp_double_arith): Update.
+	(mac_mem, sh4_fpscr_toggle): New insn_reservations.
+	* sh4a.md (sh4a_mov, sh4a_load, sh4a_store, sh4a_fp_arith): Update.
+	(sh4a_fp_double_arith): Likewise.
+	* sh4-300.md: New file.
+	* sh.c (sh_handle_option): Handle m4-300* options.
+	(sh_adjust_cost): Fix latency of auto-increments.
+	Handle SH4-300 differently than other SH4s.  Check for new insn types.
+	* sh.h (OVERRIDE_OPTIONS): Initilize sh_branch_cost if it has not been
+	set by an option.
+	* sh.opt (m4-300, m4-100-nofpu, m4-200-nofpu): New options.
+	(m4-300-nofpu, -m4-340, m4-300-single, m4-300-single-only): Likewise.
+	(mbranch-cost=, mload-latency=): Likewise.
+	* superh.h (STARTFILE_SPEC): Take -m4-340 into account.
+
+	* sh.md (mulsf3): Remove special expansion code.
+	(mulsf3_ie): Now a define_insn_and_split.
+	(macsf3): Allow for TARGET_SH4.
+
+	* config/sh/predicates.md (less_comparison_operator): Remove
+	redundant code.
+
+	* sh.md (cbranchsi4, cbranchdi4, cbranchdi4_i): New patterns.
+	* sh.c (prepare_cbranch_operands, expand_cbranchsi4): New functions.
+	(expand_cbranchdi4): Likewise.
+	(sh_rtx_costs): Give lower cost for certain CONST_INT values and for
+	CONST_DOUBLE if the outer code is COMPARE.
+	* sh.h (OPTIMIZATION_OPTIONS): If not optimizing for size, set
+	TARGET_CBRANCHDI4 and TARGET_EXPAND_CBRANCHDI4.
+	(OVERRIDE_OPTIONS): For TARGET_SHMEDIA, clear TARGET_CBRANCHDI4.
+	(LEGITIMATE_CONSTANT_P): Also allow DImode and VOIDmode CONST_DOUBLEs.
+	Remove redundant fp_{zero,one}_operand checks.
+	* sh.opt (mcbranchdi, mexpand-cbranchdi, mcmpeqdi): New options.
+	* sh-protos.h (prepare_cbranch_operands, expand_cbranchsi4): Declare.
+	(expand_cbranchdi4): Likewise.
+
+2006-04-20  J"orn Rennecke <joern.rennecke@st.com>
+
+	PR middle-end/27226
+	* builtins.c (get_pointer_alignment): Use get_inner_reference.
+
+	* sh.h (LEGITIMATE_CONSTANT_P): Allow VOIDmode CONST_DOUBLEs.
+
+2006-04-20  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.h (LOCAL_ALIGNMENT): Use DATA_ALIGNMENT.
+
+2006-04-11  J"orn Rennecke <joern.rennecke@st.com>
+
+	PR target/27060
+	http://gcc.gnu.org/ml/gcc-patches/2006-04/msg00412.html
+	* config/sh/lib1funcs.h: New file, broken out of:
+	* config/sh/lib1funcs.asm.
+	* config/sh/lib1funcs.h (DR00, DR01, DR20, DR21, DR40, DR41):
+	New macros.
+	* config/sh/lib1funcs.asm (udivsi3_i4): Use them.
+	* config/sh/lib1funcs-Os-4-200.asm: New file.
+	* config/sh/embed-elf.h (LIBGCC_SPEC): Use -lgcc-Os-4-200.
+	* config/sh/t-sh (OPT_EXTRA_PARTS): New variable.
+	(EXTRA_MULTILIB_PARTS): Include it.
+	($(T)sdivsi3_i4i-Os-4-200.o): New rule.
+	($(T)udivsi3_i4i-Os-4-200.o, $(T)libgcc-Os-4-200.a): Likewise.
+	* config/sh/t-superh (EXTRA_MULTILIB_PARTS): Include OPT_EXTRA_PARTS.
+	* config/sh/sh.h (OVERRIDE_OPTIONS): Recognize -mdiv=call-table for
+	TARGET_SH2.
+
+2006-04-11  J"orn Rennecke <joern.rennecke@st.com>
+
+	* gthr-generic.h: Update to match
+	http://gcc.gnu.org/ml/gcc-patches/2006-04/msg00237.html .
+	* gthr-generic.c, gthr-objc-generic.c: Likewise.
+	* Makefile.in configure.ac: Likewise.
+	* configure: Regenerate.
+
+2006-04-05  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/lib1funcs.h: New file, broken out of:
+	* config/sh/lib1funcs.asm.
+	* config/sh/lib1funcs-Os-4-200.asm: New file.
+
+2006-03-27  Andrew Stubbs  <andrew.stubbs@st.com>
+
+	* gcc.c (read_specs): Add Cygwin path support for MinGW.
+	(find_a_file, process_file): Likewise.
+	* opts.c (common_handle_option): Likewise.
+	* prefix.c (update_path): Likewise.
+	* c-opts.c (c_common_handle_option): Likewise.
+	(check_deps_environment_vars): Likewise.
+	* c-incpath.c (add_path): Likewise.
+	* collect2.c (find_a_file, add_prefix): Likewise.
+	* Makefile.in (INSTALL_HEADERS): Disable the broken install-mkheaders.
+
+2006-03-27  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/t-sh ($(T)libic_invalidate_array_4-100.a): Fix rule
+	to use lib prefix for target.
+	($(T)libic_invalidate_array_4-200.a): Likewise.
+	($(T)libic_invalidate_array_4a.a): Likewise.
+
+2006-03-24  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/superh.opt: New file.
+	* config/sh/sh.c (boardtype, osruntime): Remove.
+	* config/sh/superh.h (SUBTARGET_OPTIONS): Remove.
+	* config.gcc (sh*-superh-elf): Add sh/superh.opt to extra_options.
+
+2006-03-24  J"orn Rennecke <joern.rennecke@st.com>
+
+	* t-sh (IC_EXTRA_PARTS): Replace ic_invalidate_array_* parts with
+	libic_invalidate_array_* parts.  Rename affected rules.
+	* embed-elf.h (LIBGCC_SPEC): Update.
+
+2006-03-24  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config.gcc (sh*-*-*): Don't use c-c ranges for tr.  Quote sed
+	arguments with ^ and/or [].
+
+2006-03-23  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config.gcc (sh-*-*): Add quoting to account for quirk of
+	Solaris /bin/sh.
+	Replace == with = in enable_incomplete_targets test.
+
+	* configure.ac (extra_libgcc_srcs setting): Fix test to use test.
+	* configure: Regenrate.
+
+2006-03-22  J"orn Rennecke <joern.rennecke@st.com>
+
+	* superh.h (SUBTARGET_LINK_SPEC): Replace LITTLE_ENDIAN_BIT with
+	MASK_LITTLE_ENDIAN.
+
+2006-03-21  J"orn Rennecke <joern.rennecke@st.com>
+
+	* config.gcc (sh*-superh-elf): Add sh/superh.h to tm_file.
+	* config/sh/sh.opt: Added to some comments.
+	* config/sh/superh.h: Removed some chaff.
+
+2006-03-21  Andrew Stubbs <andrew.stubbs@st.com>
+	    J"orn Rennecke <joern.rennecke@st.com>
+
+	* config/sh/sh.opt: Add m4-[1234]00* options.
+	* config/sh/sh.c (sh_handle_option): Likewise.
+	* config/sh/t-sh (IC_EXTRA_PARTS, EXTRA_MULTILIB_PARTS): Define.
+	(ic_invalidate_array_4-100.o): New rule.
+	($(T)ic_invalidate_array_4-100.a): Likewise.
+	(ic_invalidate_array_4-200.o): Likewise.
+	($(T)ic_invalidate_array_4-200.a): Likewise.
+	* config/sh/t-elf (EXTRA_MULTILIB_PARTS): Add IC_EXTRA_PARTS.
+	* config/sh/embed-elf.h (LIBGCC_SPEC): Add clauses for m4-100*,
+	m4-200*, m4-300* and m4a*.
+	* config/sh/crt1.asm: Merged in profiling code.
+	* config/sh/superh.h (STARTFILE_SPEC): Override.
+	* config/sh/t-superh: Override EXTRA_MULTILIB_PARTS.
+	Add rules for $(T)crt1-mmu.o, $(T)gcrt1-mmu.o and $(T)gcrt1.o.
+	* config.gcc (sh*-superh-elf): Add t-superh to tmake_file.
+
+	* t-sh (MULTILIB_MATCHES): Add sh4-[1245]00* variants.
+	* config/sh/t-superh: Removed now-redundant MULTILIB_OPTIONS /
+	MULTILIB_DIRNAMES / MULTILIB_MATCHES settings.
+
+2006-03-21  J"orn Rennecke <joern.rennecke@st.com>
+
+	Apply patch to re-instate struct-equiv code for crossjump
+	matching:
+	http://gcc.gnu.org/ml/gcc-patches/2006-02/msg01488.html
+	Bernd Schmidt  <bernds@redhat.com>
+	* cfgcleanup.c
+	* cfgrtl.c
+	* cfgcleanup.c
+	* basic-block.h
+	* cfgcleanup.c
+	* struct-equiv.c
+
+2006-03-21  J"orn Rennecke <joern.rennecke@st.com>
+
+	* struct-equiv.c (note_local_live): Replace secondary_reload_class
+	call with SECONDARY_OUTPUT_RELOAD_CLASS use.
+
+2006-03-17  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.opt (mpretend-cmove): New option.
+	* sh.h (OPERRIDE_OPTIONS): Switch it off if not TARGET_SH1.
+	* sh.md (movsicc_t_false, movsicc_t_tru): New patterns.
+	(movsicc): Add TARGET_PRETEND_CMOVE code.
+
+2006-03-15  J"orn Rennecke <joern.rennecke@st.com>
+
+	* version.c (VERSUFFIX, bug_report_url): Customize for STM.
+
+2006-03-10  J"orn Rennecke <joern.rennecke@st.com>
+
+	http://gcc.gnu.org/ml/gcc-patches/2006-03/msg00602.html
+	* regmove.c (init_add_limits): Check find_matches to verify a
+	three-address-add instruction is genuine.
+
+2006-03-10  J"orn Rennecke <joern.rennecke@st.com>
+            Zack Weinberg <zack@codesourcery.com>
+
+	http://gcc.gnu.org/ml/gcc-patches/2006-03/msg00598.html
+	* c-incpath.c (add_path): If HAVE_DOS_BASED_FILESYSTEM is defined,
+	remove any trailing slashes except for the first one after a colon.
+
+2006-03-09  J"orn Rennecke <joern.rennecke@st.com>
+
+	http://gcc.gnu.org/ml/gcc-patches/2006-03/msg00540.html
+	* struct-equiv.c (rtx_equiv_p): Fix POST_MODIFY case.
+
+2006-03-09  J"orn Rennecke <joern.rennecke@st.com>
+
+	Merge struct-equiv code from mainline:
+
+	2006-03-04  Kazu Hirata  <kazu@codesourcery.com>
+	  * struct-equiv.c: Fix comment typos.  Follow spelling conventions.
+	2006-01-12  Ulrich Weigand  <uweigand@de.ibm.com>
+	  * struct-equiv.c (find_dying_inputs): Fix off-by-one bug.
+	2005-12-19  J"orn Rennecke <joern.rennecke@st.com>
+	  * cfgcleanup.c: Temporarily revert patches for PR 20070 till Bernd
+	  comes back.
+	2005-12-19  J"orn Rennecke <joern.rennecke@st.com>
+	  * struct-equiv.c (struct_equiv_improve_checkpoint): Fix sets_cc0_p
+	  check.
+	2005-12-17  Kazu Hirata  <kazu@codesourcery.com>
+	  PR rtl-optimization/25456
+	  * struct-equiv.c (struct_equiv_improve_checkpoint): Replace
+	  info->x_start with p->x_start.
+	2005-12-16  Kazu Hirata  <kazu@codesourcery.com>
+	  * struct-equiv.c: Fix comment typos.
+	2005-12-14  J"orn Rennecke <joern.rennecke@st.com>
+	  * struct-equiv.c (note_local_live): Handle hard regs with different
+	  hard_regno_nregs.
+	2005-12-14  J"orn Rennecke <joern.rennecke@st.com>
+	  * struct-equiv.c (rtx_equiv_p): Allow arbitrary RVALUE values for
+	  PARALLELs with a mode.
+	2005-12-14  J"orn Rennecke <joern.rennecke@st.com>
+	  PR bootstrap/25397:
+	  * struct-equiv.c (struct_equiv_init): Fix off-by-one error in clearing
+	  of STACK_REGS bits.
+	  * struct-euiv.c (rtx_equiv_p): Remove SUBREG case.
+	2005-12-13  J"orn Rennecke <joern.rennecke@st.com>
+	  PR rtl-optimization/20070 / part1
+	  * flow.c (update_life_info): If PROP_POST_REGSTACK is set, call
+	  count_or_remove_death_notes with kill == -1.
+	  (mark_set_1): Don't add REG_DEAD / REG_UNUSED notes for stack
+	  registers if PROP_POST_REGSTACK is set.
+	  (mark_used_reg): Likewise.
+	  (count_or_remove_death_notes): If kill is -1, don't remove REG_DEAD /
+	  REG_UNUSED notes for stack regs.
+	  * cfgcleanup.c (condjump_equiv_p): Change parameters and processing
+	  to match rtx_equiv_p machinery.  Change caller.
+	  (outgoing_edges_match): Likewise.
+	  (try_crossjump_to_edge): Use struct_equiv_block_eq
+	  instead of flow_find_cross_jump.
+	  * basic-block.h (PROP_POST_REGSTACK, STRUCT_EQUIV_START): Define.
+	  (STRUCT_EQUIV_RERUN, STRUCT_EQUIV_FINAL): Likewise.
+	  (STRUCT_EQUIV_NEED_FULL_BLOCK, STRUCT_EQUIV_MATCH_JUMPS): Likewise.
+	  (STRUCT_EQUIV_MAX_LOCAL): Likewise.
+	  (struct struct_equiv_checkpoint, struct equiv_info): Likewise.
+	  (insns_match_p): Update prototype.
+	  (flow_find_cross_jump): Remove prototype.
+	  (struct_equiv_block_eq, struct_equiv_init): Declare.
+	  (rtx_equiv_p, condjump_equiv_p): Likewise.
+	  * struct-equiv.c: Include reload.h.
+	  (IMPOSSIBLE_MOVE_FACTOR): Define.
+	  (assign_reg_reg_set, struct_equiv_make_checkpoint): New functions.
+	  (struct_equiv_improve_checkpoint): Likewise.
+	  (struct_equiv_restore_checkpoint, rtx_equiv_p): Likewise.
+	  (set_dest_equiv_p, set_dest_addr_equiv_p, struct_equiv_init): Likewise.
+	  (struct_equiv_merge, find_dying_input): Likewise.
+	  (resolve_input_conflict, note_local_live): Likewise.
+	  (death_notes_match_p): Change parameters and processing
+	  to match rtx_equiv_p machinery.  Change caller.
+	  (insns_match_p): Likewise.
+	  (flow_find_cross_jump): Replace with:
+	  (struct_equiv_block_eq).
+	  Back out this change:
+	  2005-03-07  Kazu Hirata  <kazu@cs.umass.edu>
+	    * recog.c (verify_changes): Make it static.
+	    * recog.h: Remove the corresponding prototype.
+	2005-12-12  J"orn Rennecke <joern.rennecke@st.com>
+	  * cfgcleanup.c (condjump_equiv_p, try_crossjump_to_edge):
+	  Fix whitespace in vincinity of to-be-installed changes.
+	  * struct-equiv.c (merge_memattrs, death_notes_match_p): Fix whitespace.
+	  (insns_match_p): Likewise.
+	2005-12-07  J"orn Rennecke <joern.rennecke@st.com>
+	  Preparation for PR rtl-optimization/20070 / part1
+	  * basic-block.h (insns_match_p, flow_find_cross_jump): Declare.
+	  * cfgcleanup.c (condjump_equiv_p): New function, broken out of
+	  outgoing_edges_match.
+	  (outgoing_edges_match): Use condjump_equiv_p.
+	  (merge_memattrs, insns_match_p, flow_find_cross_jump): Move from here
+	  into..
+	  * struct-equiv.c: New file.
+	  (death_notes_match_p) New function, broken out of insns_match_p.
+	  * Makefile.in (OBJS-common): Add struct-equiv.o.
+	  (struct-equiv.o): New target.
+
+2006-03-09  J"orn Rennecke <joern.rennecke@st.com>
+
+	* configure.ac: Unset is_release.
+	* configure: Regenerate.
+
+2006-03-09  Andrew Stubbs <andrew.stubbs@st.com>
+	    J"orn Rennecke <joern.rennecke@st.com>
+
+	http://gcc.gnu.org/ml/gcc-patches/2006-03/msg00538.html
+	* configure.ac (.eh_frame data check): Use diff -b.
+	* configure: Regenerate.
+
+2006-01-20  J"orn Rennecke <joern.rennecke@st.com>
+
+	http://gcc.gnu.org/ml/gcc-patches/2006-01/msg01387.html
+	* postreload.c (reload_combine): For every new use of REG_SUM, record
+	the use of BASE.
+
+2006-01-17  Antony King <anthony.king@st.com>
+            J"orn Rennecke <joern.rennecke@st.com>
+
+	* configure.ac: Recognize 'generic' value for threads.
+	Check for existance of a *.c and gthr-objc-*.c file for thread support.
+	Substiture in extra_libgcc_srcs and extra_libgcc_static_srcs.
+	* configure: Regenerate.
+	* Makefile.in (LIB2ADD): Add @extra_libgcc_srcs@.
+	(LIB2ADD_ST): Add @extra_libgcc_static_srcs@.
+	* gthr-generic.h: New file.
+	* gthr-generic.c: New file.
+	* gthr-objc-generic.c: New file.
+
+2005-09-15  J"orn Rennecke <joern.rennecke@st.com>
+	    Bernd Schmidt  <bernds@redhat.com>
+
+	PR rtl-optimization/20211
+	http://gcc.gnu.org/ml/gcc-patches/2005-09/msg01176.html
+	* common.opt: Add optimize-related-values entry.
+	* opts.c (decode_options): Set flag_optimize_related_values.
+	* optabs.c (gen_add3_insn): If direct addition is not possible,
+	try to move the constant into the destination register first.
+	* regmove.c (obstack.h, ggc.h, optabs.h): Include.
+	(related, rel_use_chain, rel_mod, rel_use): New structures.
+	(related_baseinfo, update): Likewise.
+	(lookup_related, rel_build_chain): New functions.
+	(recognize_related_for_insn, record_reg_use, create_rel_use): Likewise.
+	(new_reg_use, rel_record_mem, new_base, invalidate_related): Likewise.
+	(find_related, find_related_toplev, chain_starts_earlier): Likewise.
+	(chain_ends_later, mod_before, remove_setting_insns): Likewise.
+	(perform_addition, modify_address): Likewise.
+	(optimize_related_values_1, optimize_related_values_0): Likewise.
+	(optimize_related_values, count_sets, link_chains): Likewise.
+	(init_add_limits): Likewise.
+	(REL_USE_HASH_SIZE, REL_USE_HASH, rel_alloc, rel_new): New macros.
+	(regno_related, rel_base_list, unrelatedly_used): New variables.
+	(related_obstack, add_limits): Likewise.
+	(regmove_optimize): Call optimize_related_values.
+	Include gt-regmove.h.
+	(have_3addr_const_add): New variable.
+	* Makefile.in (gt-regmove.h): New rule.
+	(regmove.o): Depend on $(OPTABS_H) and gt-regmove.h.
+	(GTFILES): Add regmove.c.
+	* doc/invoke.texi: Document -foptimize-related-values.
+
+2005-09-15  J"orn Rennecke <joern.rennecke@st.com>
+
+	* regmove.c (discover_flags_reg): Use the PATTERN of an INSN.
+
+	* regmove.c (fixup_match_1): When moving a death note, check if
+	it needs changing into a REG_UNUSED note.
+
+2005-06-02  J"orn Rennecke <joern.rennecke@st.com>
+
+	* sh.c (max_labelno_before_reorg): New variable.
+	(sh_reorg): Initialize it.
+	(find_barrier): Check max_labelno_before_reorg before using
+	label_to_alignment.  Take length of explicit alignment insns
+	into account.  When seeing a UNSPECV_CONST_END, return it.
+
+	* sh.c (fixup_mova): Set mode of affected label to QImode.
+	(untangle_mova): New function.
+	(find_barrier): Use it.  Check mode of label before decrementing
+	num_mova.
+	(sh_reorg): Likewise.
+	Set mode of all insns back to VOIDmode.
+
+	* sh.c (MOVA_LABELREF): New macro.
+	(mova_p, fixup_mova, sh_reorg): Use it.
+	(find_barrier, sh_reorg): Don't count num_mova back to 0 unless
+	ADDR_DIFF_VEC matches mova.
+
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/c-incpath.c gcc-4.1.1/gcc/c-incpath.c
--- gcc-4.1.1.orig/gcc/c-incpath.c	2005-06-25 03:02:01.000000000 +0100
+++ gcc-4.1.1/gcc/c-incpath.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 /* Set up combined include path chain for the preprocessor.
    Copyright (C) 1986, 1987, 1989, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
    1999, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
    Broken out of cppinit.c and cppfiles.c and rewritten Mar 2003.
 
@@ -338,8 +339,23 @@      trailing or otherwise, cause no pro
   char* c;
   for (c = path; *c; c++)
     if (*c == '\\') *c = '/';
+
+/* The native stat() on NT4 accepts trailing slashes, but not
+    backslashes.  Mingw's stat on Windows 2000/XP doesn't accept
+    either trailing slashes or backslashes.  (C:/ and C:\ are of
+    course fine.)  It is harmless to remove trailing slashes on
+    systems that do accept them, so we do it unconditionally.  */
+  while (c > path+1 && c[-1] == '/')
+    c--;
+  if (c == path+2 
+      && ISALPHA (path[0]) && path[1] == ':' && path[2] == '/')
+    c++;
+  if (*c == '/')
+    *c = '\0';
 #endif
 
+  CYGPATH_REPLACE (&path);
+
   p = xmalloc (sizeof (cpp_dir));
   p->next = NULL;
   p->name = path;
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/collect2.c gcc-4.1.1/gcc/collect2.c
--- gcc-4.1.1.orig/gcc/collect2.c	2005-08-19 02:20:34.000000000 +0100
+++ gcc-4.1.1/gcc/collect2.c	2006-08-10 09:56:05.000000000 +0100
@@ -5,6 +5,7 @@    Copyright (C) 1992, 1993, 1994, 1995,
    Contributed by Chris Smith (csmith@convex.com).
    Heavily modified by Michael Meissner (meissner@cygnus.com),
    Per Bothner (bothner@cygnus.com), and John Gilmore (gnu@cygnus.com).
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -570,7 +571,10 @@ find_a_file (struct path_prefix *pprefix
 {
   char *temp;
   struct prefix_list *pl;
-  int len = pprefix->max_len + strlen (name) + 1;
+  int len;
+
+  CYGPATH (name);
+  len = pprefix->max_len + strlen (name) + 1;
 
   if (debug)
     fprintf (stderr, "Looking for '%s'\n", name);
@@ -596,6 +600,7 @@ 	  strcpy (temp, name);
 	  if (debug)
 	    fprintf (stderr, "  - found: absolute path\n");
 
+	  CYGPATH_FREE (name);
 	  return temp;
 	}
 
@@ -606,7 +611,10 @@       strcpy (temp, name);
 	strcat (temp, HOST_EXECUTABLE_SUFFIX);
 
 	if (access (temp, X_OK) == 0)
-	  return temp;
+	  {
+	    CYGPATH_FREE (name);
+	    return temp;
+	  }
 #endif
 
       if (debug)
@@ -623,7 +631,10 @@ 	strcat (temp, name);
 	if (stat (temp, &st) >= 0
 	    && ! S_ISDIR (st.st_mode)
 	    && access (temp, X_OK) == 0)
-	  return temp;
+	  {
+	    CYGPATH_FREE (name);
+	    return temp;
+	  }
 
 #ifdef HOST_EXECUTABLE_SUFFIX
 	/* Some systems have a suffix for executable files.
@@ -633,7 +644,10 @@ 	strcat (temp, HOST_EXECUTABLE_SUFFIX);
 	if (stat (temp, &st) >= 0
 	    && ! S_ISDIR (st.st_mode)
 	    && access (temp, X_OK) == 0)
-	  return temp;
+	  {
+	    CYGPATH_FREE (name);
+	    return temp;
+	  }
 #endif
       }
 
@@ -641,6 +655,7 @@   if (debug && pprefix->plist == NULL)
     fprintf (stderr, "  - failed: no entries in prefix list\n");
 
   free (temp);
+  CYGPATH (name);
   return 0;
 }
 
@@ -663,6 +678,7 @@       for (pl = pprefix->plist; pl->next
 
   /* Keep track of the longest prefix.  */
 
+  CYGPATH (prefix);
   len = strlen (prefix);
   if (len > pprefix->max_len)
     pprefix->max_len = len;
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/combine.c gcc-4.1.1/gcc/combine.c
--- gcc-4.1.1.orig/gcc/combine.c	2006-02-24 01:37:22.000000000 +0000
+++ gcc-4.1.1/gcc/combine.c	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 /* Optimize by combining instructions for GNU compiler.
    Copyright (C) 1987, 1988, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
    1999, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.
+   Copyright (c) 2006  STMicroelectronics.
 
 This file is part of GCC.
 
@@ -1601,7 +1602,7 @@   if (regno < info->regno)
     new_mask >>= info->regno - regno;
   else
     new_mask <<= regno - info->regno;
-  info->mask &= new_mask;
+  info->mask &= ~new_mask;
 }
 
 /* Return nonzero iff part of the return value is live during INSN, and
@@ -1637,7 +1638,8 @@   mask = (2U << (nregs - 1)) - 1;
   info.nregs = nregs;
   info.mask = mask;
   for (p = PREV_INSN (use); info.mask && p != insn; p = PREV_INSN (p))
-    note_stores (PATTERN (insn), likely_spilled_retval_1, &info);
+    if (INSN_P (p))
+      note_stores (PATTERN (p), likely_spilled_retval_1, &info);
   mask = info.mask;
 
   /* Check if any of the (probably) live return value registers is
diff -ruNdp -F'(' gcc-4.1.1.orig/gcc/common.opt gcc-4.1.1/gcc/common.opt
--- gcc-4.1.1.orig/gcc/common.opt	2006-05-17 19:38:58.000000000 +0100
+++ gcc-4.1.1/gcc/common.opt	2006-08-10 09:56:05.000000000 +0100
@@ -1,6 +1,7 @@
 ; Options for the language- and target-independent parts of the compiler.
 
 ; Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
+; Copyright (c) 2006  STMicroelectronics.
 ;
 ; This file is part of GCC.
 ;
@@ -606,6 +607,10 @@ foptimize-register-move
 Common Report Var(flag_regmove)
 Do the full register move optimization pass
 
+foptimize-related-values
+Common Report Var(flag_optimize_related_values)
+Enable additional regmove optimization for base reg + offset expressions
+
 foptimize-sibling-calls
 Common Report Var(flag_optimize_sibling_calls)
 Optimize sibling and tail recursive calls
